import { Component, OnInit, Input, ViewEncapsulation } from '@angular/core';
import { FormGroup } from '@angular/forms';
import { Section } from '../models/Section';
import { FieldGroup } from '../models/FieldGroup';
import { FormArray } from '@angular/forms/src/model';
import { DatasetProfileModel } from '../models/DatasetProfileModel';


@Component({
  selector: 'section-form',
  templateUrl: './section-form.component.html',
  styleUrls: ['./section-form.component.css'],
  encapsulation: ViewEncapsulation.None
})

export class SectionFormComponent {
  @Input() form: FormGroup;
  @Input() dataModel: Section;
  @Input() indexPath: string;

  constructor() { }

  ngOnInit() {
    //this.addGroupField(); //for new DatasetProfile
  }

  addGroupField() {
    let fieldGroup: FieldGroup = new FieldGroup();
    if (this.dataModel.fieldGroups)
      this.dataModel.fieldGroups.push(fieldGroup);
    (<FormArray>this.form.get("fieldGroups")).push(fieldGroup.buildForm());
  }

  DeleteFieldGroup(index) {
    this.dataModel.fieldGroups.splice(index, 1);
    (<FormArray>this.form.get("fieldGroups")).removeAt(index)
  }

  addSectioninSection() {
    let section: Section = new Section();
    this.dataModel.sections.push(section);
    (<FormArray>this.form.get("sections")).push(section.buildForm());
  }

  DeleteSectionInSection(index) {
    this.dataModel.sections.splice(index);
    (<FormArray>this.form.get("sections")).removeAt(index);
  }

}